<template>
  <div class="preorder-date-selector" ref="wrapper" @mouseleave="open = false">
    <div class="popup-container">
      <div class="label">{{ $t("preorderGroup.estimatedPickupTime") }}</div>
      <dropdown
        @toggle="toggle"
        :opened="open"
        :value="
          times.length && dates.length
            ? value
            : $t('restaurant.preorderNotStarted')
        "
      />
      <div class="popup" v-if="open">
        <date-selector
          @close="open = false"
          @dateChanged="date => $emit('dateChanged', date)"
          @timeChanged="time => $emit('timeChanged', time)"
          :date="date"
          :time="time"
          :dates="dates"
          :times="times"
        />
      </div>
    </div>
  </div>
</template>

<script>
import DateSelector from "./DateSelector";
import Dropdown from "@/components/Dropdown";
import * as groupPresenter from "@/presenters/group";

export default {
  components: {
    DateSelector,
    Dropdown
  },

  props: {
    date: Date,
    time: String,
    dates: Array,
    times: Array
  },

  data() {
    return {
      open: false
    };
  },

  computed: {
    value() {
      return this.date && this.time
        ? groupPresenter.formatDate(this.date) + " " + this.time
        : "";
    }
  },

  methods: {
    toggle() {
      this.open = !this.open;
    },

    clickOutSideHandler(e) {
      if (this.$refs.wrapper.contains(e.target)) {
        return;
      }
      this.open = false;
    }
  },

  mounted() {
    document.addEventListener("click", this.clickOutSideHandler);
  },

  destroyed() {
    document.removeEventListener("click", this.clickOutSideHandler);
  }
};
</script>

<style lang="scss" scoped>
.preorder-date-selector {
  width: 412px;
  padding: 10px 16px;
  border-radius: 2px;
  box-sizing: border-box;
  background: $color-white;
  box-shadow: 0 4px 4px 0 rgba(0, 0, 0, 0.05);

  @include media-breakpoint-down(md) {
    width: 100%;
    margin-top: 12px;

    .label {
      text-align: left;
    }
  }

  .label {
    margin-bottom: 10px;
    font-size: 14px;
  }

  .popup-container {
    position: relative;
  }

  .popup {
    position: absolute;
    top: 100%;
    left: 0;
    border-radius: 4px;
    background: $color-white;
    padding: 20px 10px 10px 20px;
    box-shadow: 0 4px 20px 0 rgba(0, 0, 0, 0.2);
    box-sizing: border-box;
    width: 498px;

    @include media-breakpoint-down(md) {
      position: inherit;
      padding: 0;
      width: 0;
      box-shadow: none;
    }
  }
}
</style>
